

!!! Listing 1: brief.xml

<?xml version="1.0" encoding="ISO-8859-1" standalone="no"?>

<!DOCTYPE brief SYSTEM "brief.dtd">

<brief>

<anrede geschlecht="f" sozial="du">Nora</anrede>

<text>habe gerade den Ulysses beendet. Mal sehen, wann
der in den USA gedruckt werden darf...</text>

<gruss>J</gruss>

</brief>

!!! Listing 2: brief.xsl

<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns="http://www.w3.org/TR/REC-html40">

<xsl:output method="html"/>

<xsl:template match="/brief">
<html>
  <body>
   <xsl:apply-templates/>
  </body>
</html>

</xsl:template>

<xsl:template match="anrede">
 <p>
  <xsl:choose>
    <xsl:when test="@sozial='du'">
      <xsl:text>Liebe</xsl:text>
      <xsl:if test="@geschlecht='m'">
        <xsl:text>r</xsl:text>
      </xsl:if>
      <xsl:text> </xsl:text>
    </xsl:when>

    <xsl:when test="@sozial='sie'">
       <xsl:choose>
         <xsl:when test="@geschlecht='m'">
           <xsl:text>Sehr geehrter Herr </xsl:text>
         </xsl:when>
         <xsl:when test="@geschlecht='f'">
           <xsl:text>Sehr geehrte Frau </xsl:text>
         </xsl:when>
       </xsl:choose>
    </xsl:when>
  </xsl:choose>

  <xsl:apply-templates/>
  <xsl:text>,</xsl:text>
 </p>
</xsl:template>

<xsl:template match="text | gruss">
  <p>
    <xsl:apply-templates/>
  </p>
</xsl:template>

</xsl:stylesheet>

!!! Listing 3: brief.html

<html xmlns="http://www.w3.org/TR/REC-html40">
   <body>
      <p>Liebe Nora</p>

      <p>habe gerade den Ulysses beendet. Mal sehen, wann
         der in den USA gedruckt werden darf...
      </p>

      <p>J</p>
   </body>
</html>

!!! Listing 4: Zwingender XSLT-Rahmen

<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns="http://www.w3.org/TR/REC-html40">

<!-- Code fr die Transformationen -->

</xsl:stylesheet>

!!! Listing 5: Wrterbuch-DTD

<!ELEMENT dictionary ( entry+ ) >

<!ELEMENT entry      ( acro?, term, expl+ ) >

<!ELEMENT acro       ( #PCDATA ) >
<!ELEMENT term       ( #PCDATA ) >
<!ELEMENT expl       ( #PCDATA ) >
<!ELEMENT ref        ( #PCDATA ) >
<!ATTLIST expl
          lang       (de|en)   "de" >

<!ATTLIST ref
          idref      IDREF   #REQUIRED >

!!! Listing 6: 

<xsl:template match="/">
 <xsl:apply-templates/>
</xsl:template>

<xsl:template match="/dictionary">
 <xsl:apply-templates/>
</xsl:template>

<xsl:template match="entry">
 <xsl:apply-templates/>
</xsl:template>

!!! Listing 7: toc.xsl

<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns="http://www.w3.org/TR/REC-html40"
  xmlns:saxon="http://icl.com/saxon"
  extension-element-prefixes="saxon">

<!-- ............list of entries.................. -->
<xsl:template match="dictionary">
<saxon:output method="html"
    file="{$dir}{$filesep}index.html"
    doctype-public="-//W3C//DTD HTML 4.0 Transitional"
    doctype-system="http://www.w3.org/TR/REC-html40"
    encoding="iso-8859-1"
    indent="yes">

  <html>
     <head>
       <meta name="author" content="Henning Behme" />
       <meta name="keywords" content="iX Web dictionary iX-Woerterbuch" />
       <title>iX Web dictionary</title>
       <link rel="stylesheet" href="dictionary.css" type="text/css"/>
     </head>

     <body>
       <table border="0" width="100%" cellspacing="0" cellpadding="5">
         <tr>
           <td rowspan="4" valign="top" width="30%">
             <img src="/ix/images/iX.mini.tr.gif" alt="iX logo"/>
           </td>
           <td>
             <h1>Web Dictionary</h1>
             <img src="/ix/images/dots/1tr.gif" alt="vertical space"
                  width="200" height="50"/>
           </td>
         </tr>

         <tr>
           <td>
             <h2>Inhalt / ToC</h2>
              <p>
<!-- die folgenden 3 Zeile farblich hervorheben (und die hier loeschen :-) -->
                <xsl:text>(</xsl:text>
                <xsl:apply-templates select="//entry" mode="do-amount"/>
                <xsl:text> Begriffe/terms)</xsl:text>
             </p>
                <img src="/ix/images/dots/1tr.gif" alt="vertical space"
                  width="200" height="20"/>
           </td>
         </tr>

         <tr>
           <td>
            <ul>
<!-- die folgenden 4 Zeile farblich hervorheben (und die hier loeschen :-) -->
             <xsl:for-each select="entry">
               <xsl:sort select="acro"/>
               <xsl:apply-templates select="acro" mode="toc"/>
             </xsl:for-each>
            </ul>
           </td>
         </tr>

<!-- die folgende Zeile farblich hervorheben (und die hier loeschen :-) -->
         <xsl:call-template name="do-foot"/> 
       </table>
     </body>
 </html>
 </saxon:output>
<!-- die folgende Zeile farblich hervorheben (und die hier loeschen :-) -->
 <xsl:message> - index: done</xsl:message>
</xsl:template>

<xsl:template match="acro" mode="toc">
<!-- die folgenden 9 Zeilen farblich hervorheben (und die hier loeschen :-) -->
  <li>
    <a>
      <xsl:attribute name="href">
        <xsl:value-of select="../@id"/>
        <xsl:text>.html</xsl:text>
      </xsl:attribute>
      <xsl:value-of select="."/>
    </a>
  </li>
</xsl:template>

<xsl:template match="entry" mode="do-amount">
<!-- die folgenden 3 Zeilen farblich hervorheben (und die hier loeschen :-) -->
  <xsl:if test="position()=last()">
    <xsl:value-of select="position()"/>
  </xsl:if>
</xsl:template>

</xsl:stylesheet>

!!! Listing 8: entry.xsl

<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns="http://www.w3.org/TR/REC-html40"
  xmlns:saxon="http://icl.com/saxon"
  extension-element-prefixes="saxon">

<xsl:variable name="thisentry"/>


<!-- .......template for dictionary's entry....... -->
<xsl:template match="entry">
  <xsl:variable name="thisentry">
    <xsl:value-of select="@id"/>
  </xsl:variable>

<saxon:output method="html"
    file="{$dir}{$filesep}{$thisentry}.html"
    doctype-public="-//W3C//DTD HTML 4.0 Transitional"
    doctype-system="http://www.w3.org/TR/REC-html40"
    encoding="iso-8859-1"
    indent="yes">

  <html>
     <head>
       <title>iX Web dictionary</title>
       <link rel="stylesheet" href="dictionary.css" type="text/css"/>
     </head>

     <body>
       <table border="0" width="100%" cellspacing="0" cellpadding="5">
         <tr>
           <td rowspan="7" valign="top" width="30%">
             <img src="/ix/images/iX.mini.tr.gif" alt="iX logo"/>
           </td>
           <td>
             <h1>Web Dictionary</h1>
             <img src="/ix/images/dots/1tr.gif" alt="vertical space"
                  width="200" height="50"/>
           </td>
         </tr>

         <tr>
           <td>
             <h2><xsl:apply-templates select="acro"/></h2>
           </td>
         </tr>

         <tr>
           <td>
         <h4><xsl:apply-templates select="term"/></h4>
             <img src="/ix/images/dots/1tr.gif" alt="vertical space"
                  width="200" height="50"/>
           </td>
         </tr>

         <tr>
           <td>
            <p class="de">
              <xsl:apply-templates select="expl[@lang='de']"/>
            </p>
           </td>
         </tr>

         <tr>
           <td>
            <p class="en">
              <xsl:apply-templates select="expl[@lang='en']"/>
            </p>
           </td>
         </tr>

         <tr>
           <td>
             <img src="/ix/images/dots/1tr.gif" alt="vertical space"
                  width="200" height="20"/>
<!-- die folgenden Zeilen bis XXX farblich hervorheben 
     (und diese loeschen) -->
             <p class="navigate">
               <xsl:if test="not(position()=1)">
                <a>
                 <xsl:attribute name="class">navigate</xsl:attribute>
                   <xsl:attribute name="href">
                     <xsl:value-of select="preceding-sibling::entry[1]/@id"/>
                   <xsl:text>.html</xsl:text>
                 </xsl:attribute>
                 <xsl:value-of select="preceding-sibling::entry[1]/acro"/>
                </a>
                 <xsl:text> </xsl:text>
                 <saxon:entity-ref name="lt"/>
                 <xsl:text> | </xsl:text>
               </xsl:if>

                 <a>
                   <xsl:attribute name="class">navigate</xsl:attribute>
                     <xsl:attribute name="href">
                     <xsl:text>index.html</xsl:text>
                   </xsl:attribute>
                   <xsl:text>Inhalt/ToC</xsl:text>
                 </a>

               <xsl:if test="not(position()=last())">
                 <xsl:text> | </xsl:text>
                 <saxon:entity-ref name="gt"/>
                 <xsl:text> </xsl:text>
                 <a>
                   <xsl:attribute name="class">navigate</xsl:attribute>
                     <xsl:attribute name="href">
                     <xsl:value-of select="following-sibling::entry/@id"/>
                     <xsl:text>.html</xsl:text>
                   </xsl:attribute>
                   <xsl:value-of select="following-sibling::entry/acro"/>
                 </a>
               </xsl:if>
             </p>
<!-- XXX -->
           </td>
         </tr>

         <xsl:call-template name="do-foot"/> 
       </table>
     </body>
 </html>
 </saxon:output>
 <xsl:message> - <xsl:value-of select="$thisentry"/>: done</xsl:message>

</xsl:template>

</xsl:stylesheet>

!!! Listing 9: dictionary.xsl

<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns="http://www.w3.org/TR/REC-html40"
  xmlns:saxon="http://icl.com/saxon"
  extension-element-prefixes="saxon">

<xsl:variable name="dir">html</xsl:variable>
<xsl:variable name="filesep" select="system-property('file.separator')"/>

<xsl:include href="div.xsl"/>
<xsl:include href="entry.xsl"/>
<xsl:include href="toc.xsl"/>

<!-- ..............root template.................. -->
<xsl:template match="/">
  <xsl:apply-templates select="dictionary" mode="toc"/>
  <xsl:apply-templates select="dictionary/entry"/>
</xsl:template>

<!-- ..............acro + tzerm.................. -->
<xsl:template match="acro | term">
  <xsl:value-of select="."/>
</xsl:template>

<xsl:template match="expl">
  <xsl:apply-templates/>
</xsl:template>

<xsl:template match="ref">
  <a>
    <xsl:attribute name="href">
      <xsl:value-of select="@idref"/>
      <xsl:text>.html</xsl:text>
    </xsl:attribute>
    <span class="acro">
      <xsl:apply-templates/>
    </span>
  </a>
</xsl:template>

</xsl:stylesheet>
